#!/bin/bash

make key_reconstruction_tb

export MODELSIM_BATCH="TRUE"

count=1
if [[ $# -gt 0 ]]; then
    count=$1
fi

for (( i = 0; i < $count; i++ )); do
    # python2 also works, my machine only has numpy for python3
    # if p is small (< 200 or so) and numpy is available a self-check of the
    # algorithm is available: add "--run_dense_comparison" to the options
    cd sw
    python3 matrix_multiplication.py -n0 2 -p 155 -dv 17 -m 4 3
    mv *.txt ../sim/matrices
    cd ../sim
    vsim -c -do scripts/key_reconstruction_test.tcl
    diff matrices/Ltr.txt matrices/Ltr_sim.txt &> matrices/${i}_diff.txt
    declare -a relevant_files=(
        "Htr"
        "Htr_dec"
        "Qtr"
        "Qtr_dec"
        "Ltr"
        "Ltr_dec"
        "Ltr_sim"
    )
    for matrix_dump in "${relevant_files[@]}"; do
        mv matrices/$matrix_dump.txt matrices/${i}_${matrix_dump}.txt
    done
    cd ..
done

unset MODELSIM_BATCH
