library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use work.system_params.all;
use work.matrix_types.all;
use work.matrix_mult_functions.all;

package memory_map is
    constant    HTR_BASE_ADDR:      addr:=  to_unsigned(0, address_bits);
    constant    QTR_BASE_ADDR:      addr:=  HTR_BASE_ADDR + N0*DV;
    constant    MUL_RES_BASE_ADDR:  addr:=  QTR_BASE_ADDR + N0*sum(M);
    constant    SUM_TMP_BASE_ADDR:  addr:=  MUL_RES_BASE_ADDR + DV*max(M);
    constant    LTR_BASE_ADDR:      addr:=  SUM_TMP_BASE_ADDR + DV*sum(M);
    constant    X_BASE_ADDR:        addr:=  LTR_BASE_ADDR + N0*sum(M)*DV;
    constant    S_BASE_ADDR:        addr:=  X_BASE_ADDR + N0*P;
    constant    SIGMA_BASE_ADDR:    addr:=  S_BASE_ADDR + P;
    constant    R_BASE_ADDR:        addr:=  SIGMA_BASE_ADDR + N0*P;
    constant    E_BASE_ADDR:        addr:=  R_BASE_ADDR + N0*P;
    constant    U_BASE_ADDR:        addr:=  E_BASE_ADDR + N0*P;
end package memory_map;
