library IEEE;
use IEEE.std_logic_1164.all;

package system_params is
    -- Helper types
    type n_array is array(natural range <>) of natural;
    type n_matrix is array(natural range <>, natural range <>) of natural;
    -- Params
    constant    N0:             natural                 :=  2;
    constant    P:              natural                 :=  155; --:=  27779; -- testing with 155 for consistency with smaller python tests
    constant    DV:             natural                 :=  17;
    constant    M:              n_array(0 to N0-1)      :=  (4, 3);
    constant    T:              natural                 :=  224;
    constant    position_bits:  natural                 :=  16;
    constant    address_bits:   natural                 :=  16;
end package system_params;

